all: const-def type-def program-def var-def proc-def-list block 
type-def: type type-def-list |
type-def-list: ID = var-type ; | ID = var-type ; type-def-list
const-def: const const-def-list |
const-def-list: ID = NUM ; | ID = STR ; | ID = NUM ; const-def-list | ID = STR ; const-def-list
program-def: program ID ; |
block: begin stmt-list end
stmt: block
stmt-list: stmt | stmt ; stmt-list |
stmt: for-stmt | if-stmt | while-stmt | repeat-stmt | assign-stmt | call-stmt | read-stmt | write-stmt | case-stmt
               | assign-file-stmt | close-file-stmt | reset-file-stmt | randomize-stmt | delete-stmt | return-stmt
if-stmt: if bool-expr then stmt | if bool-expr then stmt else stmt
bool-expr: expr
expr: expr-b | + expr | - expr | not expr
expr-b: expr-a | expr-b < expr-a | expr-b > expr-a | expr-b = expr-a | expr-b <> expr-a | expr-b >= expr-a | expr-b <= expr-a 
               | expr-b or expr-a | expr-b and expr-a | expr-b in expr-a
expr-a: expr-a + expr-t | expr-a - expr-t | expr-t
expr-t: expr-t / expr-f | expr-t * expr-f | expr-t div expr-f | expr-t mod expr-f | expr-f
expr-f: NUM | STR | ( expr ) | id-or-array | call-stmt | random-call | length-call | expr-set
expr-set: [ expr-set-in ] | [ ] 
expr-set-in: NUM | NUM , expr-set-in
for-stmt: for assign-stmt to expr do stmt | for assign-stmt downto expr do stmt
call-stmt: PID proc-args
assign-stmt: id-or-array := expr 
id-or-array: ID | ID index
case-stmt: case expr of case-items end
case-items: LABEL stmt-list case-items |
index: [ expr ] | [ expr ] index
proc-args: ( proc-args-in )  |
proc-args-in: expr | expr , proc-args-in
read-stmt: read ( read-args ) | readln ( read-args ) | readln
read-args: id-or-array | id-or-array , read-args
write-stmt: write proc-args | writeln proc-args 
repeat-stmt: repeat stmt-list until bool-expr 
while-stmt: while bool-expr do stmt
definitions: var-def proc-def
var-type: integer | real | text | array [ array-size-list ] of var-type | string | string [ NUM ] | set of NUM .. NUM | byte | boolean | char 
      | symple-type
array-size-list: array-size | array-size , array-size-list
array-size: NUM | NUM .. NUM
var-def: var var-list |
var-list: variable ; | variable ; var-list
variable: i-list : var-type
i-list: ID | ID , i-list
proc-def-list: proc-func-def ; proc-def-list |
proc-func-def: proc-def | func-def
proc-def: procedure header ; body 
func-def: function header : var-type ; body 
body: var-def block
header: PID | PID ( header-list )
header-list: variable | variable ; header-list | var variable | var variable ; header-list
assign-file-stmt: assign ( ID , ID )
reset-file-stmt: reset ( ID )
close-file-stmt: close ( ID )
randomize-stmt: randomize
random-call: random ( NUM )
length-call: length ( ID )
delete-stmt: delete ( ID , expr , expr )
return-stmt: return expr
.

